import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import { Button, Paper } from "@mui/material";
import IconButton from "@mui/material/IconButton";
import { Catenary } from "catenary-curve";
import { LazyBrush } from "lazy-brush";
import React from "react";
import CreatableSelect from "react-select/creatable";
import ResizeObserver from "resize-observer-polyfill";
import drawImage from "./DrwaImage";
import CheckIcon from "@mui/icons-material/Check";
import TrashIcon from "@mui/icons-material/Delete";
import { asMutable } from "seamless-immutable";

var BrushPopUp = /*#__PURE__*/function (_React$Component) {
  _inherits(BrushPopUp, _React$Component);

  function BrushPopUp(props) {
    _classCallCheck(this, BrushPopUp);

    return _possibleConstructorReturn(this, _getPrototypeOf(BrushPopUp).call(this, props));
  }

  _createClass(BrushPopUp, [{
    key: "render",
    value: function render() {
      var _this$props$lines,
          _this = this;

      return /*#__PURE__*/React.createElement(React.Fragment, null, (_this$props$lines = this.props.lines) === null || _this$props$lines === void 0 ? void 0 : _this$props$lines.map(function (item, index) {
        return /*#__PURE__*/React.createElement(Paper, {
          style: {
            position: "absolute",
            zIndex: 1000,
            top: item.points[item.points.length - 1].y / 1.2,
            left: item.points[item.points.length - 1].x / 2.8
          }
        }, item.popUp.open ? /*#__PURE__*/React.createElement("div", {
          style: {
            width: 200,
            padding: 10
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            display: "flex",
            flexDirection: "row"
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            display: "flex",
            backgroundColor: "red",
            color: "#fff",
            padding: 4,
            paddingLeft: 8,
            paddingRight: 8,
            borderRadius: 4,
            fontWeight: "bold",
            textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
          }
        }, "Brush"), /*#__PURE__*/React.createElement("div", {
          style: {
            flexGrow: 1
          }
        }), /*#__PURE__*/React.createElement(IconButton, {
          onClick: function onClick(e) {
            var linessave = _toConsumableArray(_this.props.lines);

            linessave.splice(index, 1);
            _this.props.lines = linessave;

            _this.props.setState(_objectSpread({}, _this.props.state, {
              lines: linessave
            }));

            var lines = _this.props.lines;
            var newArr = lines.splice(index, 1);

            _this.props.clear();

            _this.props.simulateDrawingLines({
              lines: lines,
              immediate: true
            });
          },
          tabIndex: -1,
          style: {
            width: 22,
            height: 22
          },
          size: "small",
          variant: "outlined"
        }, /*#__PURE__*/React.createElement(TrashIcon, {
          style: {
            marginTop: -8,
            width: 16,
            height: 16
          }
        }))), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 6
          }
        }, /*#__PURE__*/React.createElement(CreatableSelect, {
          placeholder: "Classification",
          onChange: function onChange(o, actionMeta) {
            var linessave = _toConsumableArray(_this.props.lines);

            _this.props.lines[index].popUp.classification = o;

            _this.props.setState(_objectSpread({}, _this.props.state, {
              lines: linessave
            }));
          },
          value: _this.props.lines[index].popUp.classification,
          options: asMutable(_this.props.lazyBrushClassification.map(function (c) {
            return {
              value: c,
              label: c
            };
          }))
        })), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 4
          }
        }, /*#__PURE__*/React.createElement(CreatableSelect, {
          value: _this.props.lines[index].popUp.tags,
          placeholder: "Tags",
          onChange: function onChange(o, actionMeta) {
            var linessave = _toConsumableArray(_this.props.lines);

            _this.props.lines[index].popUp.tags = o;

            _this.props.setState(_objectSpread({}, _this.props.state, {
              lines: linessave
            }));
          },
          isMulti: true,
          options: asMutable(_this.props.lazyBrushTags.map(function (c) {
            return {
              value: c,
              label: c
            };
          }))
        })), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 4,
            display: "flex"
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            flexGrow: 1
          }
        }), /*#__PURE__*/React.createElement(Button, {
          onClick: function onClick() {
            var linessave = _toConsumableArray(_this.props.lines);

            _this.props.lines[index].popUp.open = false;

            _this.props.setState(_objectSpread({}, _this.state, {
              lines: linessave
            }));
          },
          size: "small",
          variant: "contained",
          color: "primary"
        }, /*#__PURE__*/React.createElement(CheckIcon, null)))) : /*#__PURE__*/React.createElement("div", {
          style: {
            padding: 8
          },
          onClick: function onClick() {
            var linessave = _toConsumableArray(_this.props.lines);

            _this.props.lines[index].popUp.open = true;
            var i = 0;

            for (i = 0; i < ((_this$props$lines2 = _this.props.lines) === null || _this$props$lines2 === void 0 ? void 0 : _this$props$lines2.length); i++) {
              var _this$props$lines2;

              if (i !== index) {
                _this.props.lines[i].popUp.open = false;
              }
            }

            _this.props.setState(_objectSpread({}, _this.props.state, {
              lines: linessave
            }));
          }
        }));
      }));
    }
  }]);

  return BrushPopUp;
}(React.Component);

export default BrushPopUp;