import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { Button, Paper } from "@mui/material";
import IconButton from "@mui/material/IconButton";
import { Catenary } from "catenary-curve";
import { LazyBrush } from "lazy-brush";
import React from "react";
import CreatableSelect from "react-select/creatable";
import ResizeObserver from "resize-observer-polyfill";
import drawImage from "./DrwaImage";
import CheckIcon from "@mui/icons-material/Check";
import TrashIcon from "@mui/icons-material/Delete";
import { asMutable } from "seamless-immutable";

function midPointBtw(p1, p2) {
  return {
    x: p1.x + (p2.x - p1.x) / 2,
    y: p1.y + (p2.y - p1.y) / 2
  };
}

var canvasTypes = [{
  name: "myPics",
  id: "myPics"
}, {
  name: "interface",
  zIndex: 14,
  id: "interface"
}, {
  name: "drawing",
  zIndex: 11,
  id: "drawing"
}, {
  name: "temp",
  zIndex: 12,
  id: "temp"
}];

var _default = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(_default, _React$PureComponent);

  function _default(props) {
    var _this;

    _classCallCheck(this, _default);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(_default).call(this, props));

    _this.componentWillUnmount = function () {
      _this.canvasObserver.unobserve(_this.canvasContainer);
    };

    _this.drawImage = function () {
      if (!_this.props.imgSrc) return;
      _this.image = new Image();
      _this.image.src = _this.props.imgSrc;

      _this.image.onload = function () {
        return drawImage({
          ctx: _this.ctx.grid,
          img: _this.image
        });
      };
    };

    _this.undo = function () {
      var lines = _this.lines.slice(0, -1);

      _this.clear();

      _this.simulateDrawingLines({
        lines: lines,
        immediate: true
      });
    };

    _this.getSaveData = function () {
      return JSON.stringify({
        lines: _this.lines,
        width: _this.state.canvasWidth,
        height: _this.state.canvasHeight
      });
    };

    _this.loadSaveData = function (saveData) {
      var immediate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _this.props.immediateLoading;

      if (typeof saveData !== "string") {
        throw new Error("saveData needs to be of type string!");
      }

      var _JSON$parse = JSON.parse(saveData),
          lines = _JSON$parse.lines,
          width = _JSON$parse.width,
          height = _JSON$parse.height;

      if (!lines || typeof lines.push !== "function") {
        throw new Error("saveData.lines needs to be an array!");
      }

      if (width === _this.state.canvasWidth && height === _this.state.canvasHeight) {
        _this.simulateDrawingLines({
          lines: lines,
          immediate: immediate
        });
      } else {
        var scaleX = _this.state.canvasWidth / width;
        var scaleY = _this.state.canvasHeight / height;
        var scaleAvg = (scaleX + scaleY) / 2;

        _this.simulateDrawingLines({
          lines: lines.map(function (line) {
            return _objectSpread({}, line, {
              points: line.points.map(function (p) {
                return {
                  x: p.x * scaleX,
                  y: p.y * scaleY
                };
              }),
              brushRadius: line.brushRadius * scaleAvg
            });
          }),
          immediate: immediate
        });
      }
    };

    _this.simulateDrawingLines = function (_ref) {
      var lines = _ref.lines,
          immediate = _ref.immediate;
      var curTime = 0;
      var timeoutGap = immediate ? 0 : _this.props.loadTimeOffset;
      lines.forEach(function (line) {
        var points = line.points,
            brushColor = line.brushColor,
            brushRadius = line.brushRadius,
            popUp = line.popUp;

        var _loop = function _loop(i) {
          curTime += timeoutGap;
          window.setTimeout(function () {
            _this.drawPoints({
              points: points.slice(0, i + 1),
              brushColor: brushColor,
              brushRadius: brushRadius,
              popUp: popUp
            });
          }, curTime);
        };

        for (var i = 1; i < points.length; i++) {
          _loop(i);
        }

        curTime += timeoutGap;
        window.setTimeout(function () {
          _this.points = points;
          _this.popUp = popUp;

          _this.saveLine({
            brushColor: brushColor,
            brushRadius: brushRadius
          });
        }, curTime);
      });
    };

    _this.handleTouchStart = function (e) {
      var _this$getPointerPos = _this.getPointerPos(e),
          x = _this$getPointerPos.x,
          y = _this$getPointerPos.y;

      _this.lazy.update({
        x: x,
        y: y
      }, {
        both: true
      });

      _this.handleMouseDown(e);

      _this.mouseHasMoved = true;
    };

    _this.handleTouchMove = function (e) {
      e.preventDefault();

      var _this$getPointerPos2 = _this.getPointerPos(e),
          x = _this$getPointerPos2.x,
          y = _this$getPointerPos2.y;

      _this.handlePointerMove(x, y);
    };

    _this.handleTouchEnd = function (e) {
      _this.handleMouseUp(e);

      var brush = _this.lazy.getBrushCoordinates();

      _this.lazy.update({
        x: brush.x,
        y: brush.y
      }, {
        both: true
      });

      _this.mouseHasMoved = true;
    };

    _this.handleMouseDown = function (e) {
      _this.isPressing = true;
    };

    _this.handleMouseMove = function (e) {
      var _this$getPointerPos3 = _this.getPointerPos(e),
          x = _this$getPointerPos3.x,
          y = _this$getPointerPos3.y;

      _this.handlePointerMove(x, y);
    };

    _this.handleMouseUp = function (e) {
      e.preventDefault();
      _this.isDrawing = false;
      _this.isPressing = false;

      _this.saveLine();
    };

    _this.handleCanvasResize = function (entries, observer) {
      var saveData = _this.getSaveData();

      var _iterator = _createForOfIteratorHelper(entries),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var entry = _step.value;
          var _entry$contentRect = entry.contentRect,
              width = _entry$contentRect.width,
              height = _entry$contentRect.height;

          _this.setCanvasSize(_this.canvas.interface, width, height);

          _this.setCanvasSize(_this.canvas.drawing, width, height);

          _this.setCanvasSize(_this.canvas.temp, width, height);

          _this.loop({
            once: true
          });
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      _this.loadSaveData(saveData, true);
    };

    _this.setCanvasSize = function (canvas, width, height) {
      canvas.width = width;
      canvas.height = height;
      canvas.style.width = width;
      canvas.style.height = height;
    };

    _this.lastPoint = {
      x: null,
      y: null
    };

    _this.getPointerPos = function (e) {
      var rect = _this.canvas.interface.getBoundingClientRect();

      var yPosition = e.clientY * _this.props.yPosition;
      var xPosition = e.clientX * _this.props.xPosition;
      var clientX = e.clientX + xPosition;
      var clientY = e.clientY + yPosition;

      if (e.changedTouches && e.changedTouches.length > 0) {
        clientX = e.changedTouches[0].clientX + xPosition;
        clientY = e.changedTouches[0].clientY + yPosition;
      }

      return {
        x: clientX - rect.left,
        y: clientY - rect.top
      };
    };

    _this.handlePointerMove = function (x, y) {
      if (_this.props.disabled) return;

      var hasChanged = _this.lazy.update({
        x: x,
        y: y
      });

      var isDisabled = !_this.lazy.isEnabled();

      if (_this.isPressing && hasChanged && !_this.isDrawing || isDisabled && _this.isPressing) {
        _this.isDrawing = true;

        _this.points.push(_this.lazy.brush.toObject());
      }

      if (_this.isDrawing && (_this.lazy.brushHasMoved() || isDisabled)) {
        _this.points.push(_this.lazy.brush.toObject());

        _this.drawPoints({
          points: _this.points,
          brushColor: _this.props.brushColor,
          brushRadius: _this.props.brushRadius
        });
      }

      _this.mouseHasMoved = true;
    };

    _this.drawPoints = function (_ref2) {
      var points = _ref2.points,
          brushColor = _ref2.brushColor,
          brushRadius = _ref2.brushRadius;
      _this.ctx.temp.lineJoin = "round";
      _this.ctx.temp.lineCap = "round";
      _this.ctx.temp.strokeStyle = brushColor;

      _this.ctx.temp.clearRect(0, 0, _this.ctx.temp.canvas.width, _this.ctx.temp.canvas.height);

      _this.ctx.temp.lineWidth = brushRadius * 2;
      var p1 = points[0];
      var p2 = points[1];

      _this.ctx.temp.moveTo(p2.x, p2.y);

      _this.ctx.temp.beginPath();

      for (var i = 1, len = points.length; i < len; i++) {
        var midPoint = midPointBtw(p1, p2);

        _this.ctx.temp.quadraticCurveTo(p1.x, p1.y, midPoint.x, midPoint.y);

        p1 = points[i];
        p2 = points[i + 1];
      }

      _this.ctx.temp.lineTo(p1.x, p1.y);

      _this.ctx.temp.stroke();
    };

    _this.saveLine = function () {
      var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          brushColor = _ref3.brushColor,
          brushRadius = _ref3.brushRadius;

      if (_this.points.length < 2) return;

      _this.lines.push({
        points: _toConsumableArray(_this.points),
        brushColor: brushColor || _this.props.brushColor,
        brushRadius: brushRadius || _this.props.brushRadius,
        popUp: _objectSpread({}, _this.popUp)
      });

      _this.points.length = 0;
      var width = _this.canvas.temp.width;
      var height = _this.canvas.temp.height;

      _this.ctx.drawing.drawImage(_this.canvas.temp, 0, 0, width, height);

      _this.ctx.temp.clearRect(0, 0, width, height);
    };

    _this.clear = function () {
      _this.lines = [];
      _this.valuesChanged = true;

      _this.ctx.drawing.clearRect(0, 0, _this.canvas.drawing.width, _this.canvas.drawing.height);

      _this.ctx.temp.clearRect(0, 0, _this.canvas.temp.width, _this.canvas.temp.height);
    };

    _this.loop = function () {
      var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref4$once = _ref4.once,
          once = _ref4$once === void 0 ? false : _ref4$once;

      if (_this.mouseHasMoved || _this.valuesChanged) {
        var pointer = _this.lazy.getPointerCoordinates();

        var brush = _this.lazy.getBrushCoordinates();

        _this.drawInterface(_this.ctx.interface, pointer, brush);

        _this.mouseHasMoved = false;
        _this.valuesChanged = false;
      }

      if (!once) {
        window.requestAnimationFrame(function () {
          _this.loop();
        });
      }
    };

    _this.drawInterface = function (ctx, pointer, brush) {
      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);
      ctx.beginPath();
      ctx.fillStyle = _this.props.brushColor;
      ctx.arc(brush.x, brush.y, _this.props.brushRadius, 0, Math.PI * 2, true);
      ctx.fill();
      ctx.beginPath();
      ctx.fillStyle = _this.props.catenaryColor;
      ctx.arc(pointer.x, pointer.y, 4, 0, Math.PI * 2, true);
      ctx.fill();

      if (_this.lazy.isEnabled()) {
        ctx.beginPath();
        ctx.lineWidth = 2;
        ctx.lineCap = "round";
        ctx.setLineDash([2, 4]);
        ctx.strokeStyle = _this.props.catenaryColor;

        _this.catenary.drawToCanvas(_this.ctx.interface, brush, pointer, _this.chainLength);

        ctx.stroke();
      }

      ctx.beginPath();
      ctx.fillStyle = _this.props.catenaryColor;
      ctx.arc(brush.x, brush.y, 2, 0, Math.PI * 2, true);
      ctx.fill();
    };

    _this.canvas = {};
    _this.ctx = {};
    _this.catenary = new Catenary();
    _this.points = [];
    _this.popUp = {};
    _this.lines = _this.props.lazyBrush;
    _this.mouseHasMoved = true;
    _this.valuesChanged = true;
    _this.isDrawing = false;
    _this.isPressing = false;
    _this.state = {
      canvasWidth: window.innerWidth,
      canvasHeight: window.innerHeight,
      lines: []
    };
    return _this;
  }

  _createClass(_default, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.lazy = new LazyBrush({
        radius: this.props.lazyRadius * window.devicePixelRatio,
        enabled: true,
        initialPoint: {
          x: window.innerWidth / 2,
          y: window.innerHeight / 2
        }
      });
      this.chainLength = this.props.lazyRadius * window.devicePixelRatio;
      this.canvasObserver = new ResizeObserver(function (entries, observer) {
        return _this2.handleCanvasResize(entries, observer);
      });
      this.canvasObserver.observe(this.canvasContainer);
      this.drawImage();
      this.loop();
      window.setTimeout(function () {
        var initX = window.innerWidth / 2;
        var initY = window.innerHeight / 2;

        _this2.lazy.update({
          x: initX - _this2.chainLength / 4,
          y: initY
        }, {
          both: true
        });

        _this2.lazy.update({
          x: initX + _this2.chainLength / 4,
          y: initY
        }, {
          both: false
        });

        _this2.mouseHasMoved = true;
        _this2.valuesChanged = true;

        _this2.clear();

        if (_this2.props.saveData) {
          _this2.loadSaveData(_this2.props.saveData);
        }
      }, 100);
      var imageElement = document.querySelector("#main-container-lazy-brush > svg");
      var width = imageElement && imageElement.getBoundingClientRect().width;
      var height = imageElement && imageElement.getBoundingClientRect().height;
      this.setState({
        canvasWidth: width,
        canvasHeight: height
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.lazyRadius !== this.props.lazyRadius) {
        this.chainLength = this.props.lazyRadius * window.devicePixelRatio;
        this.lazy.setRadius(this.props.lazyRadius * window.devicePixelRatio);
      }

      if (prevProps.saveData !== this.props.saveData) {
        this.loadSaveData(this.props.saveData);
      }

      if (JSON.stringify(prevProps) !== JSON.stringify(this.props)) {
        this.valuesChanged = true;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this,
          _this$lines;

      var imageElement = document.querySelector("#main-container-lazy-brush > svg");
      var width = imageElement && imageElement.getBoundingClientRect().width;
      var height = imageElement && imageElement.getBoundingClientRect().height;
      var top = imageElement && imageElement.style.top;
      var left = imageElement && imageElement.style.left;

      window.lazyCords = function () {
        return _this3.lines || [];
      };

      return /*#__PURE__*/React.createElement("div", {
        className: "lazyBrushContainer",
        ref: function ref(container) {
          if (container) {
            _this3.canvasContainer = container;
          }
        },
        style: {
          width: "100%",
          height: "100%",
          position: "absolute",
          top: 0,
          left: 0
        }
      }, canvasTypes.map(function (_ref5) {
        var name = _ref5.name,
            zIndex = _ref5.zIndex,
            id = _ref5.id;
        var isInterface = name === "interface";
        var brush = _this3.props.selectedTool === "create-a-brush";
        var style = {
          top: "".concat(top),
          left: "".concat(left),
          height: "".concat(height, "px"),
          width: "".concat(width, "px"),
          position: "absolute",
          zIndex: zIndex
        };

        if (id === "myPics") {
          style = _objectSpread({}, style, {
            height: "500px",
            width: "500px",
            top: 0,
            left: 0
          });
        }

        return /*#__PURE__*/React.createElement("canvas", {
          key: name,
          ref: function ref(canvas) {
            if (canvas) {
              _this3.canvas[name] = canvas;
              _this3.ctx[name] = canvas.getContext("2d");
              if (id === "myPics") _this3.props.setCanvasRef(canvas);
            }
          },
          style: style,
          id: id,
          width: "500",
          height: "500",
          onMouseDown: isInterface && brush ? _this3.handleMouseDown : undefined,
          onMouseMove: isInterface && brush ? _this3.handleMouseMove : undefined,
          onMouseUp: isInterface && brush ? _this3.handleMouseUp : undefined,
          onMouseOut: isInterface && brush ? _this3.handleMouseUp : undefined,
          onTouchStart: isInterface && brush ? _this3.handleTouchStart : undefined,
          onTouchMove: isInterface && brush ? _this3.handleTouchMove : undefined,
          onTouchEnd: isInterface && brush ? _this3.handleTouchEnd : undefined,
          onTouchCancel: isInterface && brush ? _this3.handleTouchEnd : undefined
        });
      }), (_this$lines = this.lines) === null || _this$lines === void 0 ? void 0 : _this$lines.map(function (item, index) {
        var _item$popUp, _item$popUp2, _item$popUp$tags;

        return /*#__PURE__*/React.createElement(Paper, {
          style: {
            position: "absolute",
            zIndex: 14,
            top: item.points[item.points.length - 1].y / 1.2,
            left: item.points[item.points.length - 1].x / 2.8,
            cursor: "pointer"
          }
        }, item.popUp.open ? /*#__PURE__*/React.createElement("div", {
          style: {
            width: 200,
            padding: 10
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            display: "flex",
            flexDirection: "row"
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            display: "flex",
            backgroundColor: "red",
            color: "#fff",
            padding: 4,
            paddingLeft: 8,
            paddingRight: 8,
            borderRadius: 4,
            fontWeight: "bold",
            textShadow: "0px 0px 5px rgba(0,0,0,0.4)"
          }
        }, "Brush"), /*#__PURE__*/React.createElement("div", {
          style: {
            flexGrow: 1
          }
        }), /*#__PURE__*/React.createElement(IconButton, {
          onClick: function onClick(e) {
            var linessave = _toConsumableArray(_this3.lines);

            linessave.splice(index, 1);
            _this3.lines = linessave;

            _this3.setState(_objectSpread({}, _this3.state, {
              lines: linessave
            }));

            var lines = _this3.lines;
            var newArr = lines.splice(index, 1);

            _this3.clear();

            _this3.simulateDrawingLines({
              lines: lines,
              immediate: true
            });
          },
          tabIndex: -1,
          style: {
            width: 22,
            height: 22
          },
          size: "small",
          variant: "outlined"
        }, /*#__PURE__*/React.createElement(TrashIcon, {
          style: {
            marginTop: -8,
            width: 16,
            height: 16
          }
        }))), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 6
          }
        }, /*#__PURE__*/React.createElement(CreatableSelect, {
          placeholder: "Classification",
          onChange: function onChange(o, actionMeta) {
            var linessave = _toConsumableArray(_this3.lines);

            _this3.lines[index].popUp.classification = o;

            _this3.setState(_objectSpread({}, _this3.state, {
              lines: linessave
            }));
          },
          value: _this3.lines[index].popUp.classification,
          options: asMutable(_this3.props.lazyBrushClassification.map(function (c) {
            return {
              value: c,
              label: c
            };
          }))
        })), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 4
          }
        }, /*#__PURE__*/React.createElement(CreatableSelect, {
          value: _this3.lines[index].popUp.tags,
          placeholder: "Tags",
          onChange: function onChange(o, actionMeta) {
            var linessave = _toConsumableArray(_this3.lines);

            _this3.lines[index].popUp.tags = o;

            _this3.setState(_objectSpread({}, _this3.state, {
              lines: linessave
            }));
          },
          isMulti: true,
          options: asMutable(_this3.props.lazyBrushTags.map(function (c) {
            return {
              value: c,
              label: c
            };
          }))
        })), /*#__PURE__*/React.createElement("div", {
          style: {
            marginTop: 4,
            display: "flex"
          }
        }, /*#__PURE__*/React.createElement("div", {
          style: {
            flexGrow: 1
          }
        }), /*#__PURE__*/React.createElement(Button, {
          onClick: function onClick() {
            var linessave = _toConsumableArray(_this3.lines);

            _this3.lines[index].popUp.open = false;

            _this3.setState(_objectSpread({}, _this3.state, {
              lines: linessave
            }));
          },
          size: "small",
          variant: "contained",
          color: "primary"
        }, /*#__PURE__*/React.createElement(CheckIcon, null)))) : /*#__PURE__*/React.createElement("div", {
          style: {
            padding: 8
          },
          onClick: function onClick() {
            var linessave = _toConsumableArray(_this3.lines);

            _this3.lines[index].popUp.open = true;
            var i = 0;

            for (i = 0; i < ((_this3$lines = _this3.lines) === null || _this3$lines === void 0 ? void 0 : _this3$lines.length); i++) {
              var _this3$lines;

              if (i !== index) {
                _this3.lines[i].popUp.open = false;
              }
            }

            _this3.setState(_objectSpread({}, _this3.state, {
              lines: linessave
            }));
          }
        }, (item === null || item === void 0 ? void 0 : (_item$popUp = item.popUp) === null || _item$popUp === void 0 ? void 0 : _item$popUp.classification) && /*#__PURE__*/React.createElement("div", {
          className: "name"
        }, /*#__PURE__*/React.createElement("div", {
          className: "circle" // style={{ backgroundColor: region.color }}

        }), item === null || item === void 0 ? void 0 : (_item$popUp2 = item.popUp) === null || _item$popUp2 === void 0 ? void 0 : _item$popUp2.classification.label), (item === null || item === void 0 ? void 0 : item.popUp.tags) && /*#__PURE__*/React.createElement("div", {
          className: "tags"
        }, item === null || item === void 0 ? void 0 : (_item$popUp$tags = item.popUp.tags) === null || _item$popUp$tags === void 0 ? void 0 : _item$popUp$tags.map(function (t) {
          return /*#__PURE__*/React.createElement("div", {
            key: t.label,
            className: "tag",
            style: {
              fontSize: "12px"
            }
          }, /*#__PURE__*/React.createElement("u", null, " ", /*#__PURE__*/React.createElement("b", null, t.label)));
        }))));
      }));
    }
  }]);

  return _default;
}(React.PureComponent);

_default.defaultProps = {
  loadTimeOffset: 5,
  lazyRadius: 12,
  brushRadius: 10,
  brushColor: "#444",
  catenaryColor: "#0a0302",
  gridColor: "rgba(150,150,150,0.17)",
  backgroundColor: "#FFF",
  hideGrid: false,
  canvasWidth: 400,
  canvasHeight: 400,
  disabled: false,
  imgSrc: "",
  saveData: "",
  immediateLoading: false
};
export { _default as default };